﻿#ifndef TROBOT_SERIAL_IO_IFACE_HPP
#define TROBOT_SERIAL_IO_IFACE_HPP

#include "TRobotConstants.hpp"


namespace TRobot
{
  struct BaseSensorData;  

  ////////////////////////////////////////////////////////////////////////////////
  /*!
   *  @brief Tロボットベースのメイン基板との通信用クラスのインタフェース(抽象基底クラス)
   *
   *  @copybrief
   */
  class SerialIOIface
  {
  public:
    virtual ~SerialIOIface();
    virtual RetCode start(const char *port) = 0; //!< 通信を開始する
    virtual RetCode stop() = 0; //!< 通信を停止する
    virtual RetCode sendWheelRotVel(int leftRotVel, int rightRotVel) = 0; //!< 回転速度指令を送信する
    virtual RetCode receiveSensorData(BaseSensorData& sensorData) = 0; //!< センサデータを受信する
  };
  
} // namespace TRobot

#endif // TROBOT_SERIAL_IO_IFACE_HPP
